export type SDashboardItemSetup_Chart_X_axis = {
    field?: string | null;
};
export type SDashboardItemSetup_Chart_Y_axis = {
    field?: string | null;
};
export type SDashboardItemSetup_Chart_Seri = {
    field?: string | null;
};
export type SDashboardItemSetup_Chart = {
    x_axis?: SDashboardItemSetup_Chart_X_axis | null;
    y_axis?: SDashboardItemSetup_Chart_Y_axis | null;
    seri?: SDashboardItemSetup_Chart_Seri | null;
};
export type SDashboardItemSetup = {
    id: string;
    title?: {
        text?: string;
        subtext?: string;
    };
    type: 'vertical-bar-chart' | 'horizontal-bar-chart' | 'line-chart' | 'pie-chart' | 'stack-area-chart' | 'stack-bar-chart' | 'step-line-chart';
    chart?: SDashboardItemSetup_Chart | null;
    extraData?: {
        compare?: {
            title?: string;
            status?: 'up' | 'down';
            value?: string;
        };
    };
};
export type SDashboardItemSetting = {
    loadingComponent?: React.JSX.Element;
    loadingComponentItem?: React.JSX.Element;
    errorComponent?: React.JSX.Element;
    setup: SDashboardItemSetup;
};
export type SDashboardItemConfiguration = SDashboardItemSetting & {
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<Array<Record<string, number | string>>>;
};
export type GetItemsParameters = {
    dashboardCode: string;
    limit?: number;
    offset?: number;
};
export type GetChartDataParameters = {
    id: string;
};
export type SDashboardConfiguration = {
    fnGetItemsAsync: (arg: GetItemsParameters) => Promise<Array<SDashboardItemSetting>>;
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<Array<Record<string, number | string>>>;
    loadingComponent?: React.JSX.Element;
    loadingComponentChartItem?: React.JSX.Element;
    errorComponent?: React.JSX.Element;
    errorComponentChartItem?: React.JSX.Element;
};
export type SDashboardProps = {
    dashboardCode: string;
    configuration: SDashboardConfiguration;
};
export type SDashboardItemProps = {
    configuration: SDashboardItemConfiguration;
};
